---
driver number: 0x00002
---

# LEDs

## Overview

The LEDs driver provides userspace with synchronous control of an array of
discrete LEDs. The LEDs can be turned on, off, and toggled.

LEDs are indexed in the array starting at 0. The order of the LEDs and the
mapping between indexes and actual LEDs is set by the kernel in the board's
main file.

## Command

  * ### Command number: `0`

    **Description**: How many LEDs are supported on this board.

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: The number of LEDs on the board, or `ENODEVICE` if this driver
    is not present on the board.

  * ### Command number: `1`

    **Description**: Turn on an LED.

    **Argument 1**: The index of the LED to turn on, starting at 0.

    **Argument 2**: unused

    **Returns**: `SUCCESS` if the LED index is valid, `EINVAL` otherwise.

  * ### Command number: `2`

    **Description**: Turn off an LED.

    **Argument 1**: The index of the LED to turn off, starting at 0.

    **Argument 2**: unused

    **Returns**: `SUCCESS` if the LED index is valid, `EINVAL` otherwise.

  * ### Command number: `3`

    **Description**: Toggle an LED. If the LED is currently on it will be turned
    off, and vice-versa.

    **Argument 1**: The index of the LED to toggle, starting at 0.

    **Argument 2**: unused

    **Returns**: `SUCCESS` if the LED index is valid, `EINVAL` otherwise.

## Subscribe

Unused for the LED driver. Will always return `ENOSUPPORT`.

## Allow

Unused for the LED driver. Will always return `ENOSUPPORT`.

